"use strict";
Object.defineProperty(exports, "__esModule", {
  value: true
});
function _export(target, all) {
  for (var name in all)
    Object.defineProperty(target, name, {
      enumerable: true,
      get: all[name]
    });
}
_export(exports, {
  builtinTransformers: function() {
    return builtinTransformers;
  },
  Context: function() {
    return Context;
  }
});
const _formatter = require("../formatter");
const _transformer = require("../transformer");
const outputFormattedError = (msg, type) => {
  if (type === "error") {
    console.error(msg);
  } else if (type === "warning") {
    console.warn(msg);
  }
};
const builtinTransformers = [
  _transformer.cleanMessageTransformer,
  _transformer.flattenCausesTransformer,
  _transformer.moduleParseErrorTransformer
];
class Context {
  constructor(options = {}) {
    this.formatters = [];
    this.transformers = [];
    this.cwd = options.cwd || process.cwd();
    this.output = options.output || outputFormattedError;
    this.type = options.type || "error";
    var _options_withSources;
    this.withSources = (_options_withSources = options.withSources) !== null && _options_withSources !== void 0 ? _options_withSources : true;
    if (Array.isArray(options.formatters)) {
      this.formatters.push(...options.formatters);
    }
    if (options.formatters !== false) {
      this.formatters.push(_formatter.prettyFormatter);
    }
    const transformers = [];
    if (options.transformers !== false) {
      transformers.push(...builtinTransformers);
    }
    if (Array.isArray(options.transformers)) {
      transformers.push(...options.transformers);
    }
  }
}
