"use strict";
Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "FriendlyErrorsWebpackPlugin", {
  enumerable: true,
  get: function() {
    return FriendlyErrorsWebpackPlugin;
  }
});
const _output = require("./core/output");
class FriendlyErrorsWebpackPlugin {
  apply(compiler) {
    compiler.hooks.done.tapPromise(this.name, async (stats) => {
      {
        const opts = {
          ...this.options,
          type: "warning"
        };
        const warnings = stats.compilation.getWarnings();
        for (const warning of warnings) {
          (0, _output.outputPrettyError)(warning, opts);
        }
      }
      {
        const opts = {
          ...this.options,
          type: "error"
        };
        const errors = stats.compilation.getErrors();
        for (const error of errors) {
          (0, _output.outputPrettyError)(error, opts);
        }
      }
    });
  }
  constructor(options) {
    this.name = "FriendlyErrorsWebpackPlugin";
    this.options = options !== null && options !== void 0 ? options : {};
  }
}
