"use strict";
Object.defineProperty(exports, "__esModule", {
  value: true
});
function _export(target, all) {
  for (var name in all)
    Object.defineProperty(target, name, {
      enumerable: true,
      get: all[name]
    });
}
_export(exports, {
  cloneObject: function() {
    return cloneObject;
  },
  cloneErrorObject: function() {
    return cloneErrorObject;
  },
  transformError: function() {
    return transformError;
  },
  formatError: function() {
    return formatError;
  }
});
const _interop_require_default = require("@swc/helpers/_/_interop_require_default");
const _lodash = /* @__PURE__ */ _interop_require_default._(require("@modern-js/utils/lodash"));
const _formatter = require("../formatter");
const cloneObject = (error) => {
  const cloned = Object.create(Object.getPrototypeOf(error));
  return _lodash.default.merge(cloned, error);
};
const cloneErrorObject = (error) => {
  const cloned = cloneObject(error);
  for (const k of Object.getOwnPropertyNames(error)) {
    cloned[k] || (cloned[k] = error[k]);
  }
  return cloned;
};
const transformError = (transformers, error) => {
  return transformers.reduce((error2, transformer) => transformer(error2) || error2, error);
};
const formatError = (formatters = [
  _formatter.baseFormatter
], error) => {
  let formatted = "";
  for (const formatter of formatters) {
    var _formatter1;
    formatted = (_formatter1 = formatter(error)) !== null && _formatter1 !== void 0 ? _formatter1 : formatted;
    if (formatted) {
      break;
    }
  }
  return formatted !== null && formatted !== void 0 ? formatted : (0, _formatter.baseFormatter)(error);
};
